/*******************************************************************************
 * Copyright (c) 2004, 2007 Actuate Corporation.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *  Actuate Corporation  - initial API and implementation
 *******************************************************************************/

package org.eclipse.birt.data.engine.aggregation;

import org.eclipse.birt.data.engine.api.aggregation.IUIInfo;
import org.eclipse.birt.data.engine.i18n.DataResourceHandle;

/**
 * 
 */

public class UIInfo implements IUIInfo
{

	protected String name;
	protected String displayName;
	protected String displayNameKey;
	private DataResourceHandle handle;

	/**
	 * 
	 * @param name
	 */
	public UIInfo( String name )
	{
		this.name = name;
	}

	/**
	 * 
	 * @param name
	 * @param displayNameKey
	 * @param toolTipKey
	 */
	public UIInfo( String name, String displayNameKey )
	{
		this( name );
		this.displayNameKey = displayNameKey;
	}

	/**
	 * 
	 * @return
	 */
	private DataResourceHandle getHandle( )
	{
		if ( handle == null )
		{
			handle = DataResourceHandle.getInstance( );
		}
		return handle;
	}

	/*
	 * (non-Javadoc)
	 * @see org.eclipse.birt.data.engine.api.aggregation.IUIInfo#getName()
	 */
	public String getName( )
	{
		return name;
	}

	/**
	 * @param name the name to set
	 */
	public void setName( String name )
	{
		this.name = name;
	}

	/*
	 * (non-Javadoc)
	 * @see org.eclipse.birt.data.engine.api.aggregation.IUIInfo#getDisplayName()
	 */
	public String getDisplayName( )
	{
		if ( displayName != null )
		{
			return displayName;
		}

		displayName = getHandle( ).getMessage( displayNameKey );

		if ( displayName == null || displayName.equals( displayNameKey ) )
		{
			displayName = name;
		}
		return displayName;
	}

	/**
	 * @param displayName the displayName to set
	 */
	public void setDisplayName( String displayName )
	{
		this.displayName = displayName;
	}

	/**
	 * @param displayNameKey the displayNameKey to set
	 */
	public void setDisplayNameKey( String displayNameKey )
	{
		this.displayNameKey = displayNameKey;
	}
}
